import './index.css';
import nameGenerator from './name-generator';
import isDef from './is-def';



// Store/retrieve the name in/from a cookie.
const cookies = document.cookie.split(';');
console.log(cookies)
let wsname = cookies.find(function(c) {
  if (c.match(/wsname/) !== null) return true;
  return false;
});
if (isDef(wsname)) {
  wsname = wsname.split('=')[1];
} else {
  wsname = nameGenerator();
  document.cookie = "wsname=" + encodeURIComponent(wsname);
}

// Set the name in the header
//document.querySelector('header>p').textContent = decodeURIComponent(wsname);

// Create a WebSocket connection to the server
const ws = new WebSocket("ws://" + window.location.host+ "/socket");

// We get notified once connected to the server
ws.onopen = (event) => {
  console.log("We are connected.");
};

// Listen to messages coming from the server. When it happens, create a new <li> and append it to the DOM.
//const messages = document.querySelector('#messages');
//let line;
ws.onmessage = (event) => {
  //line = document.createElement('li');
  //line.textContent = event.data;
  //messages.appendChild(line);
  let dataOther = JSON.parse(event.data);
  console.log("event: " + dataOther);

  if(dataOther.name != decodeURIComponent(wsname))
    drawOther(dataOther.x, dataOther.y, dataOther.originx, dataOther.oringiny, dataOther.color);

};

// Retrieve the input element. Add listeners in order to send the content of the input when the "return" key is pressed.
function sendMessage(event) {
  // Send data through the WebSocket
  //var data = {"name":wsname, "image":event}
  console.log(event);
  ws.send(event);
}



var letters = '0123456789ABCDEF';
var color = '#';
for (var i = 0; i < 6; i++) {
   color += letters[Math.floor(Math.random() * 16)];
}

var click = false;
var canvas = document.getElementById("canvas");
var context = canvas.getContext("2d");
var offset = offset(document.getElementById("canvas"));
var originX = null;
var originY = null;

canvas.addEventListener("mousedown", mouseEnter);
canvas.addEventListener("mouseup", mouseExit);
canvas.addEventListener("mouseleave", mouseExit);
canvas.addEventListener("mousemove", mouseMove);

function mouseEnter(event){
  let rect = document.getElementById("canvas").getBoundingClientRect(), bodyElt = document.body;
  let top = rect.top + bodyElt .scrollTop;
  let left = rect.left + bodyElt .scrollLeft;

  click = true;
  originX = event.pageX - left;
  originY = event.pageY - top;
}

function mouseExit(event){
  click = false;
  originX = 0;
  originY = 0;
}

function mouseMove(event){
  if(click){
    draw(event.pageX, event.pageY);
  }
}

function draw(xPointer, yPointer){
  let dataCanvas = {"name":decodeURIComponent(wsname), "x":xPointer, "y":yPointer, "originx":originX, "originy":originY, "color":color};
  sendMessage(JSON.stringify(dataCanvas) );

  let rect = document.getElementById("canvas").getBoundingClientRect(), bodyElt = document.body;
  let top = rect.top + bodyElt .scrollTop;
  let left = rect.left + bodyElt .scrollLeft;

  let realX = (xPointer - left);
  let realY = (yPointer - top);
  //console.log("index x canvas: " + realX + " x: " + originX +" y canvas: " + realY);

  context.beginPath();
  context.moveTo(originX, originY);
  context.lineTo(realX, realY);
  context.strokeStyle = color;
  context.stroke();

  originX = realX;
  originY = realY;

}

var otherOX = null
var otherOY = null;

function drawOther(oXPointer, oYPointer, oOriginX, oOriginY, oColor){
  console.log("another person draw");

  let oRect = document.getElementById("canvas").getBoundingClientRect(), bodyElt = document.body;
  let oTop = oRect.top + bodyElt .scrollTop;
  let oLeft = oRect.left + bodyElt .scrollLeft;

  otherOX = oOriginX;
  otherOY = oOriginY;

  let oRealX = (oXPointer - oLeft);
  let oRealY = (oYPointer - oTop);
  console.log("other index x canvas: " + oRealX + " x: " + oOriginX +" index y canvas: " + oRealY + " y" + oYPointer);

  context.beginPath();
  context.moveTo((oRealX+2), (oRealY+2) );
  context.lineTo(oRealX, oRealY);
  context.strokeStyle = oColor;
  context.stroke();

  otherOX = oRealX;
  otherOY = oRealY;

}

function offset(elt) {
    var rect = elt.getBoundingClientRect(), bodyElt = document.body;
    return {
        top: rect.top + bodyElt .scrollTop,
        left: rect.left + bodyElt .scrollLeft
    }
}
